import { isNumber as S, isString as G, getPrefixCls as U, isObject as K } from "@gx-design-vue/pro-utils";
import { defineComponent as Y, ref as c, computed as E, onBeforeUnmount as q, watch as L, createVNode as g, Transition as V, withDirectives as _, vShow as J, Fragment as Q, nextTick as j, onMounted as Z } from "vue";
import { useEventListener as A, isClient as p, useResizeObserver as D } from "@vueuse/core";
import { useContext as ee, getTransitionProps as te, Keyframe as F, useProStyle as le } from "@gx-design-vue/pro-provider";
const ae = {
  /**
   * @description height of scrollbar
   */
  height: {
    type: [String, Number],
    default: ""
  },
  /**
   * @description max height of scrollbar
   */
  maxHeight: {
    type: [String, Number],
    default: ""
  },
  /**
   * @description whether to use the native scrollbar
   */
  native: {
    type: Boolean,
    default: !1
  },
  /**
   * @description style of wrap
   */
  barStyle: {
    type: [Object, String],
    default: ""
  },
  wrapStyle: {
    type: [Object, String],
    default: ""
  },
  /**
   * @description class of wrap
   */
  wrapClass: {
    type: [String, Array],
    default: ""
  },
  /**
   * @description class of view
   */
  viewClass: {
    type: [String, Array],
    default: ""
  },
  /**
   * @description style of view
   */
  viewStyle: {
    type: [Object, String],
    default: ""
  },
  /**
   * @description do not respond to container size changes, if the container size does not change, it is better to set it to optimize performance
   */
  noresize: Boolean,
  // 如果 container 尺寸不会发生变化，最好设置它可以优化性能
  /**
   * @description element tag of the view
   */
  tag: {
    type: String,
    default: "div"
  },
  /**
   * @description always show
   */
  always: Boolean,
  /**
   * @description minimum size of scrollbar
   */
  minSize: {
    type: Number,
    default: 20
  }
}, oe = {
  scroll: ({ scrollTop: e, scrollLeft: v }) => S(e) && S(v)
}, { useInjectContext: ne, provideContext: ie } = ee("scrollbar"), re = {
  always: {
    type: Boolean,
    default: !0
  },
  width: String,
  height: String,
  ratioX: {
    type: Number,
    default: 1
  },
  ratioY: {
    type: Number,
    default: 1
  },
  barStyle: {
    type: [Object, String],
    default: ""
  }
}, se = {
  vertical: Boolean,
  size: String,
  move: Number,
  ratio: {
    type: Number,
    required: !0
  },
  always: Boolean,
  barStyle: {
    type: [Object, String],
    default: ""
  }
}, ue = {
  vertical: {
    offset: "offsetHeight",
    scroll: "scrollTop",
    scrollSize: "scrollHeight",
    size: "height",
    key: "vertical",
    axis: "Y",
    client: "clientY",
    direction: "top"
  },
  horizontal: {
    offset: "offsetWidth",
    scroll: "scrollLeft",
    scrollSize: "scrollWidth",
    size: "width",
    key: "horizontal",
    axis: "X",
    client: "clientX",
    direction: "left"
  }
}, ce = (e) => G(e) ? !Number.isNaN(Number(e)) : !1, fe = ({ move: e, size: v, bar: n }) => ({
  [n.size]: v,
  transform: `translate${n.axis}(${e}%)`
});
function I(e, v = "px") {
  if (!e)
    return "";
  if (S(e) || ce(e))
    return `${e}${v}`;
  if (G(e))
    return e;
  console.warn("utils/dom/style", "value 必须为数字");
}
const X = /* @__PURE__ */ Y({
  props: se,
  setup(e) {
    const {
      hashId: v,
      wrapElement: n,
      scrollbarElement: b,
      className: y
    } = ne(), i = c(), s = c(), m = c({}), r = c(!1);
    let f = !1, w = !1, a = p ? document.onselectstart : null;
    const l = E(() => ue[e.vertical ? "vertical" : "horizontal"]), N = E(() => fe({
      size: e.size,
      move: e.move,
      bar: l.value
    })), C = E(() => (
      // offsetRatioX = original width of thumb / current width of thumb / ratioX
      // offsetRatioY = original height of thumb / current height of thumb / ratioY
      // instance height = wrap height - GAP
      i.value[l.value.offset] ** 2 / n.value[l.value.scrollSize] / ((e == null ? void 0 : e.ratio) || 0) / s.value[l.value.offset]
    )), H = (o) => {
      if (!s.value || !i.value || !n.value) return;
      const h = Math.abs(o.target.getBoundingClientRect()[l.value.direction] - o[l.value.client]), u = s.value[l.value.offset] / 2, t = (h - u) * 100 * C.value / i.value[l.value.offset];
      n.value[l.value.scroll] = t * n.value[l.value.scrollSize] / 100;
    }, T = (o) => {
      if (!i.value || !s.value || f === !1) return;
      const h = m.value[l.value.axis];
      if (!h) return;
      const u = (i.value.getBoundingClientRect()[l.value.direction] - o[l.value.client]) * -1, t = s.value[l.value.offset] - h, d = (u - t) * 100 * C.value / i.value[l.value.offset];
      n.value[l.value.scroll] = d * n.value[l.value.scrollSize] / 100;
    }, P = () => {
      document.onselectstart !== a && (document.onselectstart = a);
    }, x = () => {
      f = !1, m.value[l.value.axis] = 0, document.removeEventListener("mousemove", T), document.removeEventListener("mouseup", x), P(), w && (r.value = !1);
    }, z = (o) => {
      o.stopImmediatePropagation(), f = !0, document.addEventListener("mousemove", T), document.addEventListener("mouseup", x), a = document.onselectstart, document.onselectstart = () => !1;
    }, W = (o) => {
      var u;
      if (o.stopPropagation(), o.ctrlKey || [1, 2].includes(o.button)) return;
      (u = window.getSelection()) == null || u.removeAllRanges(), z(o);
      const h = o.currentTarget;
      h && (m.value[l.value.axis] = h[l.value.offset] - (o[l.value.client] - h.getBoundingClientRect()[l.value.direction]));
    }, B = () => {
      w = !1, r.value = !!e.size;
    }, M = () => {
      w = !0, r.value = f;
    };
    return q(() => {
      P(), document.removeEventListener("mouseup", x);
    }), L(() => b.value, (o) => {
      A(o, "mousemove", B), A(o, "mouseleave", M);
    }), () => {
      const o = te(`${y}-fade`);
      return g(V, o, {
        default: () => [_(g("div", {
          ref: i,
          style: e.barStyle,
          class: [`${y}-bar`, "is-" + l.value.key, v.value],
          onMousedown: H
        }, [g("div", {
          ref: s,
          class: `${y}-thumb ${v.value}`,
          style: N.value,
          onMousedown: W
        }, null)]), [[J, e.always || r.value]])]
      });
    };
  }
});
X.inheritAttrs = !1;
const ve = /* @__PURE__ */ Y({
  inheritAttrs: !1,
  props: re,
  setup(e, {
    expose: v
  }) {
    const n = c(0), b = c(0), y = 4;
    return v({
      handleScroll: (s) => {
        if (s) {
          const m = s.offsetHeight - y, r = s.offsetWidth - y;
          b.value = s.scrollTop * 100 / m * e.ratioY, n.value = s.scrollLeft * 100 / r * e.ratioX;
        }
      }
    }), () => g(Q, null, [g(X, {
      move: n.value,
      barStyle: e.barStyle,
      ratio: e.ratioX,
      size: e.width,
      always: e.always
    }, null), g(X, {
      move: b.value,
      barStyle: e.barStyle,
      ratio: e.ratioY,
      size: e.height,
      vertical: !0,
      always: e.always
    }, null)]);
  }
}), de = new F("fadeIn", {
  "0%": {
    opacity: 0
  },
  "100%": {
    opacity: 1
  }
}), me = new F("fadeOut", {
  "0%": {
    opacity: 1
  },
  "100%": {
    opacity: 0
  }
}), he = (e) => ({
  [`${e.componentCls}`]: {
    position: "relative",
    height: "100%",
    overflow: "hidden",
    "&-wrap": {
      height: "100%",
      overflow: "auto",
      "&-hidden-default": {
        scrollbarWidth: "none",
        "&::-webkit-scrollbar": {
          display: "none"
        }
      }
    },
    "&-bar": {
      position: "absolute",
      right: 2,
      bottom: 2,
      zIndex: 1,
      borderRadius: 4,
      "&.is-vertical": {
        top: 2,
        width: 6,
        "& > div": {
          width: "100%"
        }
      },
      "&.is-horizontal": {
        left: 2,
        height: 6,
        "& > div": {
          height: "100%"
        }
      }
    },
    "&-thumb": {
      position: "relative",
      display: "block",
      width: 0,
      height: 0,
      cursor: "pointer",
      backgroundColor: "rgba(0, 0, 0, 0.25)",
      borderRadius: e.borderRadius,
      transition: ".3s background-color",
      "&:hover": {
        backgroundColor: "rgba(0, 0, 0, 0.4)"
      }
    },
    "&-fade-appear, &-fade-enter": {
      animationName: de,
      animationDuration: ".34s",
      animationTimingFunction: "ease-out"
    },
    "&-fade-leave": {
      animationName: me,
      animationDuration: ".34s",
      animationTimingFunction: "ease-out"
    }
  }
}), ge = /* @__PURE__ */ Y({
  name: "GScrollbars",
  props: ae,
  emits: oe,
  setup(e, {
    emit: v,
    slots: n,
    attrs: b,
    expose: y
  }) {
    const i = U({
      suffixCls: "scrollbar"
    }), {
      wrapSSR: s,
      hashId: m
    } = le("ScrollBar", [he], i);
    let r, f;
    const w = c(), a = c(), l = c(), N = c("0"), C = c("0"), H = c(), T = c(1), P = c(1), x = "GScrollbars", z = 4, W = E(() => {
      const t = {};
      return e.height && (t.height = I(e.height)), e.maxHeight && (t.maxHeight = I(e.maxHeight)), [e.wrapStyle, t];
    }), B = () => {
      var t;
      a.value && ((t = H.value) == null || t.handleScroll(a.value), v("scroll", {
        scrollTop: a.value.scrollTop,
        scrollLeft: a.value.scrollLeft
      }));
    };
    function M(t, d) {
      K(t) ? a.value.scrollTo(t) : S(t) && S(d) && a.value.scrollTo(t, d);
    }
    const o = (t) => {
      if (!S(t)) {
        console.warn(x, "value 必须为数字");
        return;
      }
      a.value.scrollTop = t;
    }, h = (t) => {
      if (!S(t)) {
        console.warn(x, "value 必须为数字");
        return;
      }
      a.value.scrollLeft = t;
    }, u = () => {
      if (!a.value) return;
      const t = a.value.offsetHeight - z, d = a.value.offsetWidth - z, O = t ** 2 / a.value.scrollHeight, R = d ** 2 / a.value.scrollWidth, $ = Math.max(O, e.minSize), k = Math.max(R, e.minSize);
      T.value = O / (t - O) / ($ / (t - $)), P.value = R / (d - R) / (k / (d - k)), C.value = $ + z < t ? `${$}px` : "", N.value = k + z < d ? `${k}px` : "";
    };
    return L(() => e.noresize, (t) => {
      t ? (r == null || r(), f == null || f()) : ({
        stop: r
      } = D(l, u), f = A("resize", u));
    }, {
      immediate: !0
    }), L(() => e.noresize, (t) => {
      t ? (r == null || r(), f == null || f()) : ({
        stop: r
      } = D(l, u), f = A("resize", u));
    }, {
      immediate: !0
    }), L(() => [e.maxHeight, e.height], () => {
      e.native || j(() => {
        var t;
        u(), a.value && ((t = H.value) == null || t.handleScroll(a.value));
      });
    }), ie({
      hashId: m,
      className: i,
      wrapElement: a,
      scrollbarElement: w
    }), Z(() => {
      e.native || j(() => u());
    }), y({
      /** @description scrollbar wrap ref */
      wrapRef: a,
      /** @description update scrollbar state manually */
      update: u,
      /** @description scrolls to a particular set of coordinates */
      scrollTo: M,
      /** @description set distance to scroll top */
      setScrollTop: o,
      /** @description set distance to scroll left */
      setScrollLeft: h,
      /** @description handle scroll event */
      handleScroll: B
    }), () => {
      const t = e.tag;
      return s(g("div", {
        ref: w,
        class: `${i} ${m.value}`,
        style: {
          ...(b == null ? void 0 : b.style) || {}
        }
      }, [g("div", {
        ref: a,
        class: [m.value, e.wrapClass, `${i}-wrap`, e.native ? "" : `${i}-wrap-hidden-default`],
        style: W.value,
        onScroll: B
      }, [g(t, {
        ref: l,
        class: [`${i}-view`, e.viewClass, m.value],
        style: e.viewStyle
      }, {
        default: () => {
          var d;
          return [(d = n.default) == null ? void 0 : d.call(n)];
        }
      })]), !e.native && g(ve, {
        ref: H,
        height: C.value,
        width: N.value,
        always: e.always,
        barStyle: e.barStyle,
        ratioX: P.value,
        ratioY: T.value
      }, null)]));
    };
  }
});
ge.inheritAttrs = !1;
export {
  ge as GScrollbars,
  ge as default,
  ae as scrollbarProps
};
